{ ENCORE ROUTER CONTROL V1.0 }
                           
OBJ
  Debug : "FullDuplexSerial" 
  Data  :  "Extended_FDSerial_128ByteBuffers"
  heart : "heartbeat"     'object that makes an LED blink for showing propeller-chip is alive and working
  
Var
  'ATTENTION !!!
  'to avoid datacrashing you have to use the value of the constant MaxStrLength
  'of the object Extended_FDSerial_128ByteBuffers !
  'For the bytearrays that are used for received strings. 
  'The value of this constant can be accessed by writing objectname#constantname 
  Byte  MyStr[Data#MaxStrLength]
 


CON    
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
PUB Start
  Data.Start(31,30,0,9600)

  'Data.Start(26,25,2,9600)
  'Debug.Start(31,30,0,9600)
  Data.SetDelimiter(04)
     
  'Data.Start(31,30,0,9600)

  'heart.Start(9,250) 'blinking on PIN 0 as Lifesignal of PropellerChip
  heart.Start(0,250) 'blinking on PIN 0 as Lifesignal of PropellerChip

  Data.str(string("Data.Start(31,30,0,9600)"))
   
  repeat 'repeat AS FAST AS POSSIBLE RxStr waits until delimiter 
    MyStr[0] := 0  
 
    GetSource(31)                                           

    data.str(string("string received",13))
    data.str(@mystr)
    data.tx(13)
    data.tx(13)
    

PUB GetSource(dst) : src | cksm, dst_1, dst_2, dst_3, dst_4

  data.str(string("PUB GetSource entered",13))
  dst := dst - 1                                                   

  dst <<= 4 << 2                                                    'Start Calculating Checksum

  dst_1 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))         
  dst_2 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_3 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_4 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))                                                                  

  cksm := (-1*((290 + dst_1 + dst_2 + dst_3 + dst_4)//256))+256 
  
  data.str(string("sending request-sequence",13))
  Data.tx(06)                                                       'Send command to get data back
  Data.tx(01)
  Data.tx(78)
  Data.tx(48)
  Data.tx(81)
  Data.tx(74)
  Data.tx(09)
  Data.hex(dst,4)
  Data.hex(cksm,2)
  data.str(string("waiting to receive str",13))
  Data.tx(04)
  'data.str(string("R",13))

  'data.tx(13)
  
  Data.rxflush                                                      'Data.rxFlush
  Data.rxstr(@mystr)                                       'Store string from equipment
  'NO WAITING HERE !
  'waitcnt(clkfreq * 2 + cnt)
  Data.tx(06)

  data.str(string("PUB GetSource finished",13))


{ the lines below are Scripting-code for Brays terminal
program TestSendingAString;

const STRING1 = 'first test';
const SensorAnswerTemplate = 'mmmbsdddddbuuuuu';

const SensorAnswerExample = 'FF1A -123.4 uuuuu';

var 
  i     : longint;

begin
  writeln(STRING1);
  comsendstr(STRING1);
    while not(i=27) do // repeat until ESC
    begin
      while not (i=4) do i:=ComReadChr();// wait for char "EOT" 
      begin
        i:=0;
        writeln('received a EOT');
        writeln('send back ')
        writeln(SensorAnswerExample);
        //
        comsendstr(SensorAnswerExample);
        comsendchr(04); // send EOT
        writeln('wait for EOT');
      end
    end;
end.
}  